unit lue;
// Kolme erilaista esimerkki tiedoston lukemista:
//   1) Luetaan , -erotettu tiedosto
//   2) Luetaan | -erotettu tiedosto
//   3) Luetaan .ini-tiedosto
// Samalla lytyy esimerkki
//   1) StringGridin kytst
//   2) TSringList -merkkijonotaulukon kytst
//   3) virheen ksittelyst try-finally -lohkon avulla
//   4) Aliohjelmasta, joka pilkkoo jonon osiin (Split)
//
// Vesa Lappalainen 23.10.1997
//

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Db, DBTables;

type
  TFormLue = class(TForm)
    Grid: TStringGrid;
    ButtonLue: TButton;
    ButtonLueTolppa: TButton;
    ButtonIni: TButton;
    Button1: TButton;
    procedure ButtonLueClick(Sender: TObject);
    procedure ButtonLueTolppaClick(Sender: TObject);
    procedure ButtonIniClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormLue: TFormLue;

implementation
uses IniFiles;

{$R *.DFM}

const MAXPARTS = 500;

{------------------------------------------------------------------------------}
{ Split  - splits s separated by ByWhat to parts, returns number of parts      }
{------------------------------------------------------------------------------}
function Split(const s:string; const ByWhat:string; var parts:TStringList):integer;
{
  s = 'st1|st2,st3'  ByWhat = '|,'  =>  'st1'      'st2'      'st3'
  s = 'st1 st2,st3'  ByWhat = '|,'  =>  'st1 st2'  ''         'st3'
  s = 'st1|st2 st3'  ByWhat = '|,'  =>  'st1'      'st2 st3'  ''
  s = 'st1 st2 st3'  ByWhat = '|,'  =>  'st1 st2 st3'
  s = 'st1,st2,st3'  ByWhat = ','   =>  'st1'      'st2'      'st3'
  s = 'st1,,st3'     ByWhat = ','   =>  'st1'      ''         'st3'

  The last ByWhat-separator is copied until not found any more.
  Default is ; (when ByWhat='')
}
var by:char; st:string; ladd,a,lb,p,i:integer;
begin
  by := ';';
  lb := Length(ByWhat);

  st := s;
  if parts = nil then parts := TStringList.Create;
  if ( parts = nil ) then begin Result := -1; exit; end;
  parts.Clear;
  ladd := 0;

  for i:=0 to MAXPARTS do begin
    if ( i < lb ) then by := ByWhat[i+1];
    p := Pos(by,st);
    if ( p <= 0 ) then begin
      if ( i < lb ) then begin continue; end;
      parts.add(st);
      for a:=parts.Count+1 to lb+1 do parts.add('');
      Result := parts.Count;
      exit;
    end;
    parts.add(copy(st,1,p-1));
    for a:=ladd+1 to i do parts.add('');
    ladd := i+1;
    delete(st,1,p);
  end;
  Result := MAXPARTS+1;
end;

procedure TFormLue.ButtonLueClick(Sender: TObject);
// Aliohjelmalla luetaan merkkijono Gridiin pilkku-erotettu tiedosto
// Erottelussa kytetn hyvksi StringListin CommaText
// ominaisuutta, joka automaattisesti erottelee pilkulla
// erotetut osat.
var f:TextFile; s : string; r: TStringList; i:integer;
begin
  i := 0;
  AssignFile(f,'nimet.txt');        // Yhdistetn tiedosto levytiedostoon
{$i-}                               // Iovirheilmoitus pois plt
  Reset(f);                         // Avataan tiedosto lukemista varten
  if ( IoResult <> 0 ) then exit;   // Jos virhe pois
  r := TStringList.Create;          // Luodaan merkkijonotaulukko
  while not eof(f) do begin         // Luetaan koko tiedosto
    readln(f,s);                    // Luetaan yksi rivi
    r.CommaText := s;               // Erotellaan , kohdalta jonoiksi
    Grid.Rows[i] := r;              // Sijoitetaan Gridin seuraavaksi riviksi
    inc(i);                         // Siirrytn seuraavalle riville
  end;
  CloseFile(f);                     // Suljetaan tiedosto
{$i+}                               // Virhetarkistus takaisin plle
  r.Free;                           // Vapautetaan merkkijonotaulukko
end;



procedure TFormLue.ButtonLueTolppaClick(Sender: TObject);
// Aliohjelmall luetaan | erotettu tiedosto StringGridiin
// siten, ett jokainen rivi on Gridin sarake.
// Aloitetaan rivist 1, sarekkeesta 1
// Virheksittely try - lohkolla
var f:TextFile; Open : Boolean; s : string; r: TStringList; i,j:integer;
begin
  i := 1;                          // Aloitetaan sarkkeesta 1
  AssignFile(f,'nimet3.txt');      // Yhdistetn tiedosto levytiedostoon
  r := NIL;                        // Tieto siit, ettei rivi ole luotu
  Open := False;                   // Tieto siit, ettei tiedosto ole auki
  try                              // Yritetn seuraavia hommia
    r := TStringList.Create;       // Luodaan merkkijonotaulukko
    Reset(f);                      // Avataan tiedosto lukemista varten
    Open := True;                  // Ja jos onnistui, niin tieto aukiolosta
    while not eof(f) do begin      // Kydn lpi koko tiedosto
      readln(f,s);                 // Luetaan rivi
      Split(s,'|',r);              // Erotellaan | kohdalta
  //    Grid.Cols[i] := r;         // Kelpaa jos saa aloittaa rivist 0
      for j:=0 to r.Count-1 do Grid.Cells[i,j+1] := r[j]; // Sarakkeeksi
      inc(i);                      // Seuraava sarake
    end;
  finally                          // Joka tapauksessa siivoaminen
    if ( Open ) then CloseFile(f); // Suljetaan tiedosto jos avattiin
    if ( r <> NIL ) then r.Free;   // Poistetaan jono jos saatiin luotua
  end;
end;


procedure TFormLue.ButtonIniClick(Sender: TObject);
(* Luetaan Gridiin nimet3.ini, joka on seuraavaa muotoa:
[Nimi1]
suku=Ankka
etu=Roope
osoite=Ankkalinna
[Nimi2]
suku=Ankka
etu=Aku
osoite=Ankkalinna
[Nimi3]
suku=Susi
etu=Sepe
osoite=Takamets
*)
var Ini:TIniFile; i:integer; sec,s:string;
begin
  Ini := TIniFile.Create('.\Nimet3.ini');   // Luodaan olio INI-tiedostoa varten
  if ( Ini = NIL ) then exit;               // Jos ei tullut, niin pois
  i := 1;                                   // Aloitetaan rivist nro 1
  Grid.Cells[1,0] := 'Suku';                // Sijoitetaan gridiin otsikot
  Grid.Cells[2,0] := 'Etu';
  Grid.Cells[3,0] := 'Osoite';
  while ( True ) do begin                   // Ikuinen silmukka
    sec := 'Nimi'+IntToStr(i);              // Katenoidaan esim. jono Nimi1
    s := Ini.ReadString(sec,'suku','');     // Yriten lukea sukunimi
    if ( s = '' ) then break;               // Jollei sukunime, lopetetaan
    Grid.Cells[0,i] := IntToStr(i);         // Rivin alkuun numero
    Grid.Cells[1,i] := s;                   // Sijoitetaan gridiin
    Grid.Cells[2,i] := Ini.ReadString(sec,'etu','');    // Luetaan etunimi
    Grid.Cells[3,i] := Ini.ReadString(sec,'osoite',''); // Luetaan osoite
    Inc(i);                                 // Seuraava rivi
  end;
end;

procedure TFormLue.Button1Click(Sender: TObject);
(* Luetaan tiedosto suoraan merkkojonotaulukkoon tai jopa grdin sarakkeeksi   *)
var r: TStringList;
begin
  r := TStringList.Create;                  // Luodaan merkkijonotaulukko
  r.LoadFromFile('nimet2.txt');             // Luetaan tiedostosta koko taulukko
  Grid.Cols[0] := r;                        // Sijoitetaan sarakkeeksi 0
  r.Free;                                   // Taulukosta eroon
  Grid.Cols[3].LoadFromFile('nimet.txt')    // Ninkin voi tehd
end;

end.
